/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package moe.nekojimi.charactermaker.steps;

import java.util.HashMap;
import java.util.Map;
import moe.nekojimi.charactermaker.RollTable;


public class ChooseMorphStep extends Step
{

	@Override
	public void run()
	{

	}

	private static enum MorphType
	{
		BIO("biomorph"),
		UPLIFT("uplift biomorph"),
		POD("pod biomorph"),
		SYNTH("synthmorph"),
		INFO("infomorph");

		String name;

		private MorphType(String name)
		{
			this.name = name;
		}

		@Override
		public String toString()
		{
			return name;
		}
	}

	private static final RollTable<MorphType> typeTable = new RollTable<>(100);
	static
	{
		typeTable.addEntry(1, ChooseMorphStep.MorphType.BIO);
		typeTable.addEntry(51, ChooseMorphStep.MorphType.UPLIFT);
		typeTable.addEntry(56, ChooseMorphStep.MorphType.POD);
		typeTable.addEntry(66, ChooseMorphStep.MorphType.SYNTH);
		typeTable.addEntry(96, ChooseMorphStep.MorphType.UPLIFT);
	}

	private static enum Morph
	{
		FLAT			(MorphType.BIO,1,"Flat","p. 139, EP",0),
		SPLICER			(MorphType.BIO,4,"Splicer","p. 139, EP",10),
		EXALT			(MorphType.BIO,14,"Exalt","p. 139, EP",30),
		MENTON			(MorphType.BIO,22,"Menton","p. 139, EP",40),
		OLYMPIAN		(MorphType.BIO,27,"Olympian","p. 140, EP",40),
		SYLPH			(MorphType.BIO,35,"Sylph","p. 140, EP",40),
		BOUNCER			(MorphType.BIO,40,"Bouncer","p. 140, EP",40),
		FURY			(MorphType.BIO,47,"Fury","p. 140, EP",75),
		FUTURA			(MorphType.BIO,50,"Futura","p. 140, EP",40),
		GHOST			(MorphType.BIO,51,"Ghost","p. 140, EP",70),
		HIBERNOID		(MorphType.BIO,54,"Hibernoid","p. 140, EP",25),
		NEOTENIC		(MorphType.BIO,57,"Neotenic","p. 141, EP",25),
		REMADE			(MorphType.BIO,60,"Remade","p. 141, EP",60),
		RUSTER			(MorphType.BIO,63,"Ruster","p. 141, EP",25),
		LUNAR_FLYER		(MorphType.BIO,70,"Lunar Flyer","p. 162, S",35),
		MARTIAN_ALPINER	(MorphType.BIO,71,"Martian Alpiner","p. 162, S",30),
		SALAMANDER		(MorphType.BIO,73,"Salamander","p. 163, S",40),
		SURYA			(MorphType.BIO,74,"Surya","p. 164, S",50),
		VENUSIAN_GLIDER	(MorphType.BIO,75,"Venusian Glider","p. 164, S",40),
		HAZER			(MorphType.BIO,76,"Hazer","p. 186, R",35),
		HULDER			(MorphType.BIO,78,"Hulder","p. 186, R",50),
		HYPERBRIGHT		(MorphType.BIO,79,"Hyperbright","p. 186, R",70),
		RING_FLYER		(MorphType.BIO,80,"Ring Flyer","p. 187, R",70),
		SELKIE			(MorphType.BIO,81,"Selkie","p. 187, R",55),
		AQUANAUT		(MorphType.BIO,82,"Aquanaut","p. 150, G",50),
		CRASHER			(MorphType.BIO,83,"Crasher","p. 150, G",70),
		DVERGR			(MorphType.BIO,86,"Dvergr","p. 150, G",50),
		ARIEL			(MorphType.BIO,87,"Ariel","p. 188",50),
		BRUISER			(MorphType.BIO,88,"Bruiser","p. 189",60),
		CLOUD_SKATE		(MorphType.BIO,90,"Cloud Skate","p. 189",55),
		FAUST			(MorphType.BIO,91,"Faust","p. 190",85),
		FREEMAN			(MorphType.BIO,92,"Freeman","p. 191",10),
		GREY			(MorphType.BIO,93,"Grey","p. 192",25),
		NOMAD			(MorphType.BIO,94,"Nomad","p. 194",30),
		OBSERVER		(MorphType.BIO,96,"Observer","p. 194",40),
		THESEUS			(MorphType.BIO,100,"Theseus","p. 196",30),
		NEO_AVIAN		(MorphType.UPLIFT,1,"Neo-Avian","p. 141, EP",25),
		NEO_HOMINID		(MorphType.UPLIFT,31,"Neo-Hominid*","p. 141, EP",25),
		OCTOMORPH		(MorphType.UPLIFT,51,"Octomorph","p. 141, EP",50),
		NEANDERTHAL		(MorphType.UPLIFT,71,"Neanderthal","p. 162, S",40),
		NEO_BELUGA		(MorphType.UPLIFT,76,"Neo-Beluga","p. 142, P",45),
		NEO_DOLPHIN		(MorphType.UPLIFT,77,"Neo-Dolphin","p. 143, P",40),
		NEO_GORILLA		(MorphType.UPLIFT,78,"Neo-Gorilla","p. 143, P",35),
		NEO_ORCA		(MorphType.UPLIFT,93,"Neo-Orca","p. 143, P",60),
		NEO_PIG			(MorphType.UPLIFT,94,"Neo-Pig","p. 143, P",20),
		NEO_PORPOISE	(MorphType.UPLIFT,99,"Neo-Porpoise","p. 143, P",35),
		NEO_WHALE		(MorphType.UPLIFT,100,"Neo-Whale","p. 143, P",75),
		PLEASURE_POD	(MorphType.POD,1,"Pleasure Pod","p. 142, EP",20),
		WORKER_POD		(MorphType.POD,16,"Worker Pod","p. 142, EP",20),
		NOVACRAB		(MorphType.POD,31,"Novacrab","p. 142, EP",60),
		DIGGER			(MorphType.POD,34,"Digger","p. 150, G",30),
		RIPWING			(MorphType.POD,36,"Ripwing","p. 151, G",40),
		SCURRIER		(MorphType.POD,39,"Scurrier","p. 151, G",40),
		WHIPLASH		(MorphType.POD,40,"Whiplash","p. 151, G",50),
		CHICKCHARNIE	(MorphType.POD,41,"Chickcharnie","p. 142, P",35),
		HYPERGIBBON		(MorphType.POD,43,"Hypergibbon","p. 142, P",30),
		SHAPER			(MorphType.POD,45,"Shaper","p. 144, P",45),
		AYAH			(MorphType.POD,47,"Ayah","p. 188",25),
		BASIC_POD		(MorphType.POD,54,"Basic Pod","p. 188",5),
		CRITTER			(MorphType.POD,63,"Critter","p. 190",15),
		FLYING_SQUID	(MorphType.POD,68,"Flying Squid","p. 191",55),
		JENKIN			(MorphType.POD,71,"Jenkin","p. 193",20),
		SAMSA			(MorphType.POD,73,"Samsa","p. 195",60),
		SECURITY_POD	(MorphType.POD,76,"Security Pod","p. 195",30),
		SPACE_MARINE	(MorphType.POD,84,"Space Marine","p. 195",30),
		SPECIALIST_POD	(MorphType.POD,87,"Specialist Pod","p. 196",25),
		VACUUM_POD		(MorphType.POD,96,"Vacuum Pod","p. 197",30),
		CASE			(MorphType.SYNTH,1,"Case","p. 143, EP",5),
		SYNTH			(MorphType.SYNTH,21,"Synth","p. 143, EP",30),
		ARACHNOID		(MorphType.SYNTH,36,"Arachnoid","p. 143, EP",45),
		DRAGONFLY		(MorphType.SYNTH,41,"Dragonfly","p. 144, EP",20),
		FLEXBOT			(MorphType.SYNTH,46,"Flexbot","p. 144, EP",20), // cost=20*
		REAPER			(MorphType.SYNTH,50,"Reaper","p. 144, EP",100),
		SLITHEROID		(MorphType.SYNTH,51,"Slitheroid","p. 144, EP",40),
		SWARMANOID		(MorphType.SYNTH,55,"Swarmanoid","p. 144, EP",25),
		Q_MORPH			(MorphType.SYNTH,59,"Q Morph","p. 163, S",100),
		STEEL_MORPH		(MorphType.SYNTH,60,"Steel Morph","p. 163, S",50),
		STEEL_MORPH_MASKED(MorphType.SYNTH,62,"Steel Morph (Masked)","p. 163, S",55),
		STEEL_MORPH_LIQUID_SILVER(MorphType.SYNTH,63,"Steel Morph (Liquid Silver)","p. 163, S",70),
		SUNDIVER		(MorphType.SYNTH,64,"Sundiver","p. 164, S",70),
		CETUS			(MorphType.SYNTH,65,"Cetus","p. 185, R",45),
		COURIER			(MorphType.SYNTH,66,"Courier","p. 185, R",70),
		FENRIR			(MorphType.SYNTH,67,"Fenrir","p. 186, R",0), // cost=NA
		SAVANT			(MorphType.SYNTH,68,"Savant","p. 187, R",65),
		KITE			(MorphType.SYNTH,69,"Kite","p. 150, G",30),
		SPARE			(MorphType.SYNTH,70,"Spare","p. 151, G",5),
		XU_FU			(MorphType.SYNTH,71,"Xu Fu","p. 151, G",60),
		GARGOYLE		(MorphType.SYNTH,73,"Gargoyle","p. 142, P",40),
		SKULKER			(MorphType.SYNTH,75,"Skulker","p. 144, P",35),
		TAKKO			(MorphType.SYNTH,76,"Takko","p. 144, P",60),
		BIOCORE			(MorphType.SYNTH,78,"Biocore","p. 188",50),
		BLACKBIRD		(MorphType.SYNTH,79,"Blackbird","p. 189",45),
		CLOUD_SKIMMER	(MorphType.SYNTH,81,"Cloud Skimmer","p. 189",65),
		DAITYA			(MorphType.SYNTH,82,"Daitya","p. 190",80),
		FIGHTING_KITE	(MorphType.SYNTH,83,"Fighting Kite","p. 190",35),
		GALATEA			(MorphType.SYNTH,84,"Galatea","p. 192",65),
		GRIEFER			(MorphType.SYNTH,86,"Griefer","p. 192",5),
		GUARD			(MorphType.SYNTH,87,"Guard","p. 192",60),
		GUARD_DELUXE	(MorphType.SYNTH,89,"Guard Deluxe","p. 193",75),
		MIMIC			(MorphType.SYNTH,90,"Mimic","p. 193",25),
		NAUTILOID		(MorphType.SYNTH,91,"Nautiloid","p. 193",155),
		OPTERYX			(MorphType.SYNTH,92,"Opteryx","p. 194",40),
		ROVER			(MorphType.SYNTH,94,"Rover","p. 194",60),
		SPACE_FIGHTER_ROVER(MorphType.SYNTH,96,"Space Fighter Rover","p. 194",60),
		SMART_SWARM		(MorphType.SYNTH,97,"Smart Swarm","p. 196",30),
		SPHERE			(MorphType.SYNTH,98,"Sphere","p. 196",65),
		SYNTHTAUR		(MorphType.SYNTH,100,"Synthtaur","p. 196",70),
		INFOMORPH		(MorphType.INFO,1,"Infomorph","p. 145, EP",0),
		AGENT			(MorphType.INFO,51,"Agent","p. 142",35),
		DIGIMORPH		(MorphType.INFO,58,"Digimorph","p. 142",25),
		ELITE			(MorphType.INFO,71,"Elite","p. 142",35),
		HOT_SHOT		(MorphType.INFO,75,"Hot Shot","p. 142",35),
		SAGE			(MorphType.INFO,82,"Sage","p. 142",40),
		SCHOLAR			(MorphType.INFO,86,"Scholar","p. 142",35),
		SLAVE			(MorphType.INFO,93,"Slave","p. 142",5),
		WIREHEAD		(MorphType.INFO,94,"Wirehead","p. 142",60),
		;

		private Morph(MorphType type, int rollMin, String name, String pageRef, int cpCost)
		{
			this.type = type;
			this.rollMin = rollMin;
			this.name = name;
			this.pageRef = pageRef;
			this.cpCost = cpCost;
		}

		MorphType type;
		int rollMin;
		String name;
		String pageRef;
		int cpCost;

		@Override
		public String toString()
		{
			return name;
		}
	}

	private static final Map<MorphType, RollTable<Morph>> morphs = new HashMap<>();
	static
	{
		for (Morph morph: Morph.values())
		{
			if (!morphs.containsKey(morph.type))
				morphs.put(morph.type, new RollTable<>(100));
			morphs.get(morph.type).addEntry(morph.rollMin, morph);
		}
	}
}
